/*BEGIN_LEGAL 
Intel Open Source License 

Copyright (c) 2002-2017 Intel Corporation. All rights reserved.
 
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.  Redistributions
in binary form must reproduce the above copyright notice, this list of
conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.  Neither the name of
the Intel Corporation nor the names of its contributors may be used to
endorse or promote products derived from this software without
specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE INTEL OR
ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
END_LEGAL */
//Child process application
#include <windows.h>
#include <stdio.h>
#include <iostream>
using namespace std;

int main(int argc, char * argv[])
{
    const int baseArgc = 3;
    if (argc < baseArgc)
    {
        //Got unexpected parameter
        cout << "Some arguments missed" << endl;
        return (-2);
    }
    CHAR * expectedArgv[baseArgc] = {{"win_child_process.exe"}, {"param1 param2"}, {"param3"}};
    string currentArgv;
    
    //Take into account that a path might be added to the executable name
    currentArgv = argv[0];
    string::size_type index = currentArgv.find(expectedArgv[0]);
    if(index == string::npos)
    {
        //Got unexpected parameter
        cout << "Got unexpected parameter: " << argv[0] << endl;
        return (-1);
    }
    //All the rest should have exact match
    for(int i = 1; i < baseArgc; i++)
    {
        currentArgv = argv[i];
        if(currentArgv.compare(expectedArgv[i]) != 0)
        {
            //Got unexpected parameter
            cout << "Got unexpected parameter: " << argv[i] << endl;
            return (-1);
        }
    }
    if (argc > baseArgc)
    {
        // Next parameter is sleep interval in milliseconds
        int msecs = atoi(argv[baseArgc]);
        if (msecs > 0)
        {
            Sleep(msecs);
        }
    }
    return 0;
}